//*****************************************************************
// 
//  JAVA Source for com.idautomation.databar; 2010
//  
//	 Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************


package com.idautomation.databar;

import java.awt.*;
import java.applet.*;

/** This is the DataBar applet that creates a barcode from the DataBar class. */
public class DataBarApplet extends Applet
{
    // ** updated for servlet operation 5/31/2001
    public DataBar BC=null;
    public boolean isStandalone=false;
    // ** end of update

    public DataBarApplet() 
    {
        this.setLayout(new java.awt.BorderLayout());
    }

    public void start() 
    {
        BC.paint(this.getGraphics());
    }

    public void refresh() 
    {
        BC.paint(BC.getGraphics());
        this.paintAll(this.getGraphics());
    }

    public void init() 
    {
        // create bar code 1D
        if (BC==null) BC=new DataBar();	

        this.add("Center",BC);	

        initParam("S");
        initParam("X");
        initParam("I");
        initParam("BH");
        initParam("BC");
        initParam("FC");
        initParam("F");
        initParam("BGC");
        initParam("CS");
        initParam("LM");
        initParam("TM");
        initParam("D");
        initParam("AI");
        initParam("O");
        initParam("ST");
        initParam("TA");
        initParam("PT");
        initParam("EM");
        initParam("CD");
        initParam("SG");
        initParam("FS");
        initParam("ECL");
        initParam("COL");
        initParam("CG");
        initParam("IR");
        initParam("XYR");
        initParam("L");
        initParam("DSH");
    }

    private void initParam(String p) 
    {
        String v=getStringParam(p,"");
        if (v.length()==0) return;
        setParameter(p,v);
    }

    public void setParameter(String p,String v) 
    {
        if (v==null) return;
        int width = 0;
        if (p.compareTo("S")==0) 
        {
            if (v.toUpperCase().compareTo("CODE128")==0 || v.compareTo("0")==0) BC.setSymbologyID(BC.CODE128);
            if (v.toUpperCase().compareTo("DATABAR")==0 || v.compareTo("1")==0) BC.setSymbologyID(BC.DATABAR);
            if (v.toUpperCase().compareTo("DATABAREXPANDED")==0 || v.compareTo("2")==0) BC.setSymbologyID(BC.DATABAREXPANDED);
            if (v.toUpperCase().compareTo("DATABARLIMITED")==0 || v.compareTo("3")==0) BC.setSymbologyID(BC.DATABARLIMITED);
            if (v.toUpperCase().compareTo("DATABARSTACKED")==0 || v.compareTo("4")==0) BC.setSymbologyID(BC.DATABARSTACKED);
            if (v.toUpperCase().compareTo("DATABAROMNI")==0 || v.compareTo("5")==0) BC.setSymbologyID(BC.DATABAROMNI);
            if (v.toUpperCase().compareTo("DATABARTRUNCATED")==0 || v.compareTo("6")==0) BC.setSymbologyID(BC.DATABARTRUNCATED);
            if (v.toUpperCase().compareTo("EAN8")==0 || v.compareTo("7")==0) BC.setSymbologyID(BC.EAN8);
            if (v.toUpperCase().compareTo("EAN13")==0 || v.compareTo("8")==0) BC.setSymbologyID(BC.EAN13);
            if (v.toUpperCase().compareTo("MICROPDF417")==0 || v.compareTo("9")==0) BC.setSymbologyID(BC.MICROPDF417);
            if (v.toUpperCase().compareTo("PDF417")==0 || v.compareTo("10")==0) BC.setSymbologyID(BC.PDF417);
            if (v.toUpperCase().compareTo("UPCA")==0 || v.compareTo("11")==0) BC.setSymbologyID(BC.UPCA);
            if (v.toUpperCase().compareTo("UPCE")==0 || v.compareTo("12")==0) BC.setSymbologyID(BC.UPCE);           
        }
        if (p.compareTo("SG")==0) BC.setExpandedStackedSegments(new Integer(v).intValue());
        if (p.compareTo("O")==0) BC.setRotationAngle((int) (new Double(v).doubleValue()));
        if (p.compareTo("X")==0) BC.X_DimensionCM=new Double(v).doubleValue();
        if (p.compareTo("BH")==0) BC.barHeightCM=new Double(v).doubleValue();
        if (p.compareTo("LM")==0) BC.leftMarginCM=new Double(v).doubleValue();
        if (p.compareTo("TM")==0) BC.topMarginCM=new Double(v).doubleValue();
        if (p.compareTo("EM")==0) BC.textMarginCM=new Double(v).doubleValue();
        if (p.compareTo("F")==0) BC.textFont=new Font(v,Font.PLAIN,BC.textFont.getSize());
        if (p.compareTo("FS")==0) BC.textFont=BC.textFont.deriveFont(new Float(v).floatValue());
        if (p.compareTo("FC")==0) BC.fontColor=convertColor(v);
        if (p.compareTo("BC")==0) BC.barColor=convertColor(v);
        if (p.compareTo("BGC")==0) BC.backColor=convertColor(v);
        if (p.compareTo("ECL")==0) BC.ecLevel=new Integer(v).intValue();
        if (p.compareTo("COL")==0) BC.setPDFColumns(new Integer(v).intValue());
        if (p.compareTo("CG")==0) BC.setCharacterGrouping(new Integer(v).intValue());
        if (p.compareTo("IR")==0) BC.setPixelsPerCM(new Integer(v).intValue());
        if (p.compareTo("XYR")==0) BC.setXtoYRatio(new Integer(v).intValue());
        if (p.compareTo("DSH")==0)
        {
            String STParameter = p;
            if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
               STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                BC.setDataBarSuggestedHeight(true);
            else
                BC.setDataBarSuggestedHeight(false);
        }
        if (p.compareTo("CS")==0)
        {
            //BC.Code128Set=new String(v+"B").charAt(0);
            char csParam = new String(v+"B").charAt(0);
            if(csParam >= '0' && csParam <= '3')
            {
                switch(csParam)
                {
                    case '0':
                    {
                        BC.setCode128Set("AUTO");
                        break;
                    }
                    case '1':
                    {
                        BC.setCode128Set("A");
                        break;
                    }
                    case '2':
                    {
                        BC.setCode128Set("B");
                        break;
                    }
                    case '3':
                    {
                        BC.setCode128Set("C");
                        break;
                    }
                }
            }
            else
                BC.setCode128Set(String.valueOf(csParam));
                
        }
        if (p.compareTo("AI")==0)
        {
            String AIParameter = v;
            if(AIParameter.toUpperCase().compareTo("Y") == 0 || AIParameter.toUpperCase().compareTo("YES") == 0 ||
               AIParameter.toUpperCase().compareTo("TRUE") == 0 || AIParameter.toUpperCase().compareTo("T") == 0)
                BC.includeAIinHRText = true;
            else
                BC.includeAIinHRText = false;
        }
        if (p.compareTo("L")==0) 
        {
            String LParameter = v;
            if(LParameter.toUpperCase().compareTo("Y") == 0 || LParameter.toUpperCase().compareTo("YES") == 0 ||
               LParameter.toUpperCase().compareTo("TRUE") == 0 || LParameter.toUpperCase().compareTo("T") == 0)
                BC.includeLinkageFlaginHRText = true;
            else
                BC.includeLinkageFlaginHRText = false;
        }
        if (p.compareTo("ST")==0)
        {
            String STParameter = v;
            if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
               STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                BC.showText = true;
            else
                BC.showText = false;
        }
        if (p.compareTo("TA")==0)
        {
            String STParameter = v;
            if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
               STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                BC.showTextLocation = BC.TOP;
            else
                BC.showTextLocation = BC.BOTTOM;
        }
        if (p.compareTo("PT")==0)
        {
            String PTParameter = v;
            if(PTParameter.toUpperCase().compareTo("Y") == 0 || PTParameter.toUpperCase().compareTo("YES") == 0 ||
               PTParameter.toUpperCase().compareTo("TRUE") == 0 || PTParameter.toUpperCase().compareTo("T") == 0)
                BC.applyTilde = true;
            else
                BC.applyTilde = false;

        }    
        if (p.compareTo("CD")==0) 
        {
            if(v.equals(""))
                BC.isComposite = false;
            else
                BC.isComposite = true;
            BC.setCompositeData(v);
        }
        if (p.compareTo("MODE")==0) 
        {
            if(v.toUpperCase().compareTo("TEXT")==0) BC.compactionMode = 0;
            if(v.toUpperCase().compareTo("BINARY")==0) BC.compactionMode = 1;
            if(v.toUpperCase().compareTo("NUMERIC")==0) BC.compactionMode = 2;
        }
        if (p.compareTo("D")==0) 
        {
            BC.setDataToEncode(v);
        }
    }

    // function to convert a String parameter to a color
    public java.awt.Color convertColor(String c) 
    {
        if (c.toUpperCase().compareTo("NULL")==0) return null;
        if (c.toUpperCase().compareTo("RED")==0) return java.awt.Color.red;
        if (c.toUpperCase().compareTo("BLACK")==0) return java.awt.Color.black;
        if (c.toUpperCase().compareTo("BLUE")==0) return java.awt.Color.blue;
        if (c.toUpperCase().compareTo("CYAN")==0) return java.awt.Color.cyan;
        if (c.toUpperCase().compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
        if (c.toUpperCase().compareTo("GRAY")==0) return java.awt.Color.gray;
        if (c.toUpperCase().compareTo("GREEN")==0) return java.awt.Color.green;
        if (c.toUpperCase().compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
        if (c.toUpperCase().compareTo("MAGENTA")==0) return java.awt.Color.magenta;
        if (c.toUpperCase().compareTo("ORANGE")==0) return java.awt.Color.orange;
        if (c.toUpperCase().compareTo("PINK")==0) return java.awt.Color.pink;
        if (c.toUpperCase().compareTo("WHITE")==0) return java.awt.Color.white;
        if (c.toUpperCase().compareTo("YELLOW")==0) return java.awt.Color.yellow;
        try 
        {
            return java.awt.Color.decode(c);
        } 
        catch (Exception e) 
        {
            return java.awt.Color.black;
        }
    }

    // ** updated for servlet operation 5/31/2001
    // get a parameter as string
    protected String getStringParam(String Param,String def) 
    {
        return this.getParameter(Param, def);
    }


    //Get a parameter value
    private String getParameter(String key, String def) 
    {
        if (isStandalone) 
            return def;

        if (this.getParameter(key) != null) 
            return this.getParameter(key) ;
        else 
            return def;
    }
    private Integer getIntParam(String Param,Integer def) 
    {
        try 
        {
            String s=this.getParameter(Param ,"");
            if (s.compareTo("")==0) 
                return def;
            return new Integer(s);
        }
        catch(Exception e) 
        {
            return def;
        }
    }

    private Double getDoubleParam(String Param,Double def) 
    {
        try 
        {
            String s=this.getParameter(Param ,"");
            if (s.compareTo("")==0) 
                return def;
            return new Double(s);
        }
        catch(Exception e) 
        {
            return def;
        }
    }
}
